>From aa3e642673c732a1864e3e32090de77de90f97b8 Mon Sep 17 00:00:00 2001
From: Adam Young <ayoung@redhat.com>
Date: Fri, 18 Nov 2011 15:03:44 -0500
Subject: [PATCH 43/45] type safety  certserv cms and cmscore

---
 pki/base/common/src/CMakeLists.txt                 |    2 -
 .../certsrv/notification/IEmailFormProcessor.java  |    4 +-
 .../certsrv/notification/IMailNotification.java    |    2 +-
 .../certsrv/pattern/AttrSetCollection.java         |    2 +-
 .../src/com/netscape/certsrv/pattern/Pattern.java  |    2 +-
 .../certsrv/policy/IGeneralNameConfig.java         |    2 +-
 .../netscape/certsrv/policy/IPolicyProcessor.java  |   16 ++--
 .../com/netscape/certsrv/policy/IPolicyRule.java   |    4 +-
 .../com/netscape/certsrv/policy/IPolicySet.java    |    2 +-
 .../netscape/certsrv/profile/CertInfoProfile.java  |    4 +-
 .../netscape/certsrv/profile/IPolicyDefault.java   |    2 +-
 .../src/com/netscape/certsrv/profile/IProfile.java |   11 +-
 .../certsrv/profile/IProfileAuthenticator.java     |    2 +-
 .../netscape/certsrv/profile/IProfileInput.java    |    2 +-
 .../netscape/certsrv/profile/IProfileOutput.java   |    2 +-
 .../certsrv/profile/IProfileSubsystem.java         |    2 +-
 .../netscape/certsrv/property/IConfigTemplate.java |    2 +-
 .../com/netscape/certsrv/property/PropertySet.java |    4 +-
 .../netscape/certsrv/publish/ILdapCertMapper.java  |   71 -----------
 .../netscape/certsrv/publish/IPublishRuleSet.java  |  124 --------------------
 .../certsrv/ra/IRegistrationAuthority.java         |    2 +-
 .../netscape/certsrv/registry/IPluginRegistry.java |    4 +-
 .../src/com/netscape/certsrv/request/IRequest.java |    2 +-
 .../com/netscape/certsrv/usrgrp/IUGSubsystem.java  |    6 +-
 .../authentication/UidPwdPinDirAuthentication.java |    4 +-
 .../cms/notification/MailNotification.java         |    2 +-
 .../netscape/cms/profile/def/EnrollDefault.java    |   22 ++--
 .../cms/profile/def/NameConstraintsExtDefault.java |    2 +-
 .../netscape/cms/profile/input/SubjectDNInput.java |    4 +-
 .../netscape/cms/profile/output/EnrollOutput.java  |    8 +-
 .../cms/servlet/admin/ProfileAdminServlet.java     |   74 +++++++-----
 .../cms/servlet/admin/RegistryAdminServlet.java    |   10 +-
 .../com/netscape/cms/servlet/base/CMSServlet.java  |    8 +-
 .../cms/servlet/profile/ProfileProcessServlet.java |    4 +-
 .../cmscore/notification/EmailFormProcessor.java   |   18 ++--
 .../cmscore/policy/GenericPolicyProcessor.java     |  104 ++++++++---------
 .../src/com/netscape/cmscore/policy/PolicySet.java |    6 +-
 .../netscape/cmscore/profile/ProfileSubsystem.java |   10 +-
 .../netscape/cmscore/registry/PluginRegistry.java  |   24 ++--
 .../netscape/cmscore/request/ARequestQueue.java    |    6 +-
 .../cmscore/selftests/SelfTestSubsystem.java       |   40 +++---
 .../src/com/netscape/cmscore/usrgrp/Group.java     |   13 +-
 .../com/netscape/cmscore/usrgrp/UGSubsystem.java   |   79 +++++++------
 43 files changed, 269 insertions(+), 445 deletions(-)
 delete mode 100644 pki/base/common/src/com/netscape/certsrv/publish/ILdapCertMapper.java
 delete mode 100644 pki/base/common/src/com/netscape/certsrv/publish/IPublishRuleSet.java

diff --git a/pki/base/common/src/CMakeLists.txt b/pki/base/common/src/CMakeLists.txt
index 12e401d8fac4b624503de77b2c65aa6244133317..a2527d2eee04144750353a8396824fab4221320b 100644
--- a/pki/base/common/src/CMakeLists.txt
+++ b/pki/base/common/src/CMakeLists.txt
@@ -111,9 +111,7 @@ set(pki-certsrv_java_SRCS
     com/netscape/certsrv/publish/ILdapRule.java
     com/netscape/certsrv/publish/IPublisherProcessor.java
     com/netscape/certsrv/publish/LdapCertMapResult.java
-    com/netscape/certsrv/publish/IPublishRuleSet.java
     com/netscape/certsrv/publish/ILdapExpression.java
-    com/netscape/certsrv/publish/ILdapCertMapper.java
     com/netscape/certsrv/publish/ILdapMapper.java
     com/netscape/certsrv/publish/PublisherPlugin.java
     com/netscape/certsrv/publish/ERulePluginNotFound.java
diff --git a/pki/base/common/src/com/netscape/certsrv/notification/IEmailFormProcessor.java b/pki/base/common/src/com/netscape/certsrv/notification/IEmailFormProcessor.java
index 9d7ee46f067effe00baac889e08a606b70ce8541..ace09a8cfe36bb500485dc2f62797efc809218cb 100644
--- a/pki/base/common/src/com/netscape/certsrv/notification/IEmailFormProcessor.java
+++ b/pki/base/common/src/com/netscape/certsrv/notification/IEmailFormProcessor.java
@@ -67,12 +67,12 @@ public interface IEmailFormProcessor {
      * @return mail content
      */
     public String getEmailContent(String form,
-        Hashtable tok2vals);
+        Hashtable<String, Object> tok2vals);
 
     /**
      * takes a vector of strings and concatenate them
      */
-    public String formContent(Vector vec);
+    public String formContent(Vector<String> vec);
 
     /**
      * logs an entry in the log file.
diff --git a/pki/base/common/src/com/netscape/certsrv/notification/IMailNotification.java b/pki/base/common/src/com/netscape/certsrv/notification/IMailNotification.java
index c5375caed8006bdcad95f9676d4a9a4c4062b637..b537fbbd2cc6e0d4e080008c7bbb03cdb78e04d0 100644
--- a/pki/base/common/src/com/netscape/certsrv/notification/IMailNotification.java
+++ b/pki/base/common/src/com/netscape/certsrv/notification/IMailNotification.java
@@ -65,7 +65,7 @@ public interface IMailNotification {
      * sets the recipients' email addresses
      * @param addresses a list of email addresses of the recipients
      */
-    public void setTo(Vector addresses);
+    public void setTo(Vector<String> addresses);
 
     /**
      * sets the recipient's email address
diff --git a/pki/base/common/src/com/netscape/certsrv/pattern/AttrSetCollection.java b/pki/base/common/src/com/netscape/certsrv/pattern/AttrSetCollection.java
index 2a9a87e39564690f44676daee4b8c4c764efdf6c..22cfc232c12b2327506634526f2b25ef5492cf19 100644
--- a/pki/base/common/src/com/netscape/certsrv/pattern/AttrSetCollection.java
+++ b/pki/base/common/src/com/netscape/certsrv/pattern/AttrSetCollection.java
@@ -28,7 +28,7 @@ import com.netscape.certsrv.base.IAttrSet;
  *
  * @version $Revision$, $Date$
  */
-public class AttrSetCollection extends Hashtable {
+public class AttrSetCollection extends Hashtable<String, IAttrSet> {
 
     /**
      *
diff --git a/pki/base/common/src/com/netscape/certsrv/pattern/Pattern.java b/pki/base/common/src/com/netscape/certsrv/pattern/Pattern.java
index d177f87b1280b399ceaf9aa9160b5ce39ed3052f..36cc7cb3bc5a359b841145edc4ae96c70aa158db 100644
--- a/pki/base/common/src/com/netscape/certsrv/pattern/Pattern.java
+++ b/pki/base/common/src/com/netscape/certsrv/pattern/Pattern.java
@@ -70,7 +70,7 @@ public class Pattern {
      */
     public String substitute(AttrSetCollection attrSetCollection) {
         String temp = mS;
-        Enumeration keys = attrSetCollection.keys();
+        Enumeration<String> keys = attrSetCollection.keys();
 
         while (keys.hasMoreElements()) {
             String key = (String) keys.nextElement();
diff --git a/pki/base/common/src/com/netscape/certsrv/policy/IGeneralNameConfig.java b/pki/base/common/src/com/netscape/certsrv/policy/IGeneralNameConfig.java
index 0d44be08166e6c2ca6c0b05f8e874d7cb5669b28..953bb41ea93cdfe283d3988dbcbf3ba95d92b514 100644
--- a/pki/base/common/src/com/netscape/certsrv/policy/IGeneralNameConfig.java
+++ b/pki/base/common/src/com/netscape/certsrv/policy/IGeneralNameConfig.java
@@ -56,7 +56,7 @@ public interface IGeneralNameConfig {
      * @return a vector of general names
      * @exception EBaseException failed to form general name
      */
-    public Vector formGeneralNames(Object value)
+    public Vector<GeneralName> formGeneralNames(Object value)
         throws EBaseException;
 
     /**
diff --git a/pki/base/common/src/com/netscape/certsrv/policy/IPolicyProcessor.java b/pki/base/common/src/com/netscape/certsrv/policy/IPolicyProcessor.java
index 834d462e0baa2f2b5032d6ec0befa17c4ff372a4..09f2415a1a375135051248645933cac9056bf09c 100644
--- a/pki/base/common/src/com/netscape/certsrv/policy/IPolicyProcessor.java
+++ b/pki/base/common/src/com/netscape/certsrv/policy/IPolicyProcessor.java
@@ -73,7 +73,7 @@ public interface IPolicyProcessor extends ISubsystem,
      * 		   about policy implementations. Currently only the
      *		   the implementation id is expected.
      */
-    Enumeration getPolicyImplsInfo();
+    Enumeration<String> getPolicyImplsInfo();
 
     /**
      * Returns the rule implementations registered with this processor.
@@ -81,7 +81,7 @@ public interface IPolicyProcessor extends ISubsystem,
      * @return An Enumeration of uninitialized IPolicyRule 
      *					objects.
      */
-    Enumeration getPolicyImpls();
+    Enumeration<IPolicyRule> getPolicyImpls();
 
     /**
      * Returns an implementation identified by a given id.
@@ -98,7 +98,7 @@ public interface IPolicyProcessor extends ISubsystem,
      * @return A vector of name/value pairs in the form of
      *	name=value.
      */
-    Vector getPolicyImplConfig(String id);
+    Vector<String> getPolicyImplConfig(String id);
 
     /**
      * Deletes a policy implementation identified by an impl id.
@@ -129,14 +129,14 @@ public interface IPolicyProcessor extends ISubsystem,
      * @return An Enumeration of Strings describing the information 
      *			about policy rule instances.
      */
-    Enumeration getPolicyInstancesInfo();
+    Enumeration<String> getPolicyInstancesInfo();
 
     /**
      * Returns policy instances registered with this processor.
      *
      * @return An Enumeration of policy instances.
      */
-    Enumeration getPolicyInstances();
+    Enumeration<IPolicyRule>  getPolicyInstances();
 
     /**
      * Returns instance configuration for a given instance id.
@@ -145,7 +145,7 @@ public interface IPolicyProcessor extends ISubsystem,
      * @return A vector of name/value pairs in the form of
      *	name=value.
      */
-    Vector getPolicyInstanceConfig(String id);
+    Vector<String>  getPolicyInstanceConfig(String id);
 
     /**
      * Returns instance configuration for a given instance id.
@@ -172,7 +172,7 @@ public interface IPolicyProcessor extends ISubsystem,
      * @param ht a Hashtable of config params.
      * @exception EBaseException is thrown if an error occurs in addition.
      */
-    void addPolicyInstance(String id, Hashtable ht)
+    void addPolicyInstance(String id, Hashtable<String, String> ht)
         throws EBaseException;
 
     /**
@@ -183,7 +183,7 @@ public interface IPolicyProcessor extends ISubsystem,
      * @param ht a Hashtable of config params.
      * @exception EBaseException is thrown if an error occurs in addition.
      */
-    void modifyPolicyInstance(String id, Hashtable ht)
+    void modifyPolicyInstance(String id, Hashtable<String, String> ht)
         throws EBaseException;
 
     /**
diff --git a/pki/base/common/src/com/netscape/certsrv/policy/IPolicyRule.java b/pki/base/common/src/com/netscape/certsrv/policy/IPolicyRule.java
index d80a0d0c2f203752be68ab4212f01c2eaa359b48..0babd48aa8137686fce7bb35c374df4f5f371e47 100644
--- a/pki/base/common/src/com/netscape/certsrv/policy/IPolicyRule.java
+++ b/pki/base/common/src/com/netscape/certsrv/policy/IPolicyRule.java
@@ -110,7 +110,7 @@ public interface IPolicyRule
      * @return nvPairs A Vector of name/value pairs. Each name/value
      *				pair is constructed as a String in name=value format.
      */
-    public Vector getInstanceParams();
+    public Vector<String> getInstanceParams();
 
     /**
      * Return default parameters for a policy implementation.
@@ -118,7 +118,7 @@ public interface IPolicyRule
      * @return nvPairs A Vector of name/value pairs. Each name/value
      *		  		pair is constructed as a String in name=value.
      */
-    public Vector getDefaultParams();
+    public Vector<String>  getDefaultParams();
 
     public void setError(IRequest req, String format, Object[] params);
 
diff --git a/pki/base/common/src/com/netscape/certsrv/policy/IPolicySet.java b/pki/base/common/src/com/netscape/certsrv/policy/IPolicySet.java
index ea12f4b1be333504eb02f4b68db28c76bb007dbb..dd5a36bcabf3048306d68f65a3de93dfa62cc029 100644
--- a/pki/base/common/src/com/netscape/certsrv/policy/IPolicySet.java
+++ b/pki/base/common/src/com/netscape/certsrv/policy/IPolicySet.java
@@ -90,7 +90,7 @@ public interface IPolicySet {
      *
      * @return An enumeration of rules.
      */
-    Enumeration getRules();
+    Enumeration<IPolicyRule> getRules();
 
     /**
      * Apply policy rules on a request. This call may modify
diff --git a/pki/base/common/src/com/netscape/certsrv/profile/CertInfoProfile.java b/pki/base/common/src/com/netscape/certsrv/profile/CertInfoProfile.java
index fae38c696dfe767b9acacf3edc0abd4b975e0ed6..75f134c2a9ff82ae8a35d056ff10bafb552b3bd0 100644
--- a/pki/base/common/src/com/netscape/certsrv/profile/CertInfoProfile.java
+++ b/pki/base/common/src/com/netscape/certsrv/profile/CertInfoProfile.java
@@ -28,7 +28,7 @@ import com.netscape.certsrv.base.IConfigStore;
 
 public class CertInfoProfile 
 {
-    private Vector mDefaults = new Vector();
+    private Vector<ICertInfoPolicyDefault> mDefaults = new Vector<ICertInfoPolicyDefault>();
     private String mName = null;
     private String mID = null;
     private String mDescription = null;
@@ -96,7 +96,7 @@ public class CertInfoProfile
 
     public void populate(X509CertInfo info)
     {
-        Enumeration e1 = mDefaults.elements();
+        Enumeration<ICertInfoPolicyDefault> e1 = mDefaults.elements();
         while (e1.hasMoreElements()) {
           ICertInfoPolicyDefault def = 
                (ICertInfoPolicyDefault)e1.nextElement();
diff --git a/pki/base/common/src/com/netscape/certsrv/profile/IPolicyDefault.java b/pki/base/common/src/com/netscape/certsrv/profile/IPolicyDefault.java
index 018054926c5741b89936068dcee057d7cff3723f..092b10fdce3d2e336f74b8569e2bbfe696cbbfbd 100644
--- a/pki/base/common/src/com/netscape/certsrv/profile/IPolicyDefault.java
+++ b/pki/base/common/src/com/netscape/certsrv/profile/IPolicyDefault.java
@@ -109,7 +109,7 @@ public interface IPolicyDefault extends IConfigTemplate {
      * @return a list of property names. The values are
      *         of type java.lang.String
      */
-    public Enumeration getValueNames();
+    public Enumeration<String> getValueNames();
 
     /**
      * Retrieves the descriptor of the given property 
diff --git a/pki/base/common/src/com/netscape/certsrv/profile/IProfile.java b/pki/base/common/src/com/netscape/certsrv/profile/IProfile.java
index c006db6793906c352f3cf4e592403d894494ba13..cc6975cdf355db415a7f123580c0dbc06267fbe4 100644
--- a/pki/base/common/src/com/netscape/certsrv/profile/IProfile.java
+++ b/pki/base/common/src/com/netscape/certsrv/profile/IProfile.java
@@ -26,6 +26,7 @@ import com.netscape.certsrv.base.IConfigStore;
 import com.netscape.certsrv.common.NameValuePairs;
 import com.netscape.certsrv.request.IRequest;
 import com.netscape.certsrv.request.IRequestQueue;
+import com.netscape.cms.profile.common.ProfilePolicy;
 
 /**
  * This interface represents a profile. A profile contains 
@@ -137,7 +138,7 @@ public interface IProfile {
      *
      * @return input policy id list
      */
-    public Enumeration getProfileInputIds();
+    public Enumeration<String> getProfileInputIds();
 
     /**
      * Retrieves input policy by id.
@@ -152,7 +153,7 @@ public interface IProfile {
      *
      * @return output policy id list
      */
-    public Enumeration getProfileOutputIds();
+    public Enumeration<String> getProfileOutputIds();
 
     /**
      * Retrieves output policy by id.
@@ -243,7 +244,7 @@ public interface IProfile {
      *
      * @return a list of policy set id
      */
-    public Enumeration getProfilePolicySetIds();
+    public Enumeration<String> getProfilePolicySetIds();
 
     /**
      * Creates a profile policy.
@@ -325,7 +326,7 @@ public interface IProfile {
      * @param setId set id
      * @return a list of policy id
      */
-    public Enumeration getProfilePolicyIds(String setId);
+    public Enumeration<String> getProfilePolicyIds(String setId);
 
     /**
      * Retrieves a default set id for the given request.
@@ -343,7 +344,7 @@ public interface IProfile {
      * @param setId set id
      * @return a list of policies
      */
-    public Enumeration getProfilePolicies(String setId);
+    public Enumeration<ProfilePolicy> getProfilePolicies(String setId);
 
     /**
      * Creates one or more requests. Normally, only one request will
diff --git a/pki/base/common/src/com/netscape/certsrv/profile/IProfileAuthenticator.java b/pki/base/common/src/com/netscape/certsrv/profile/IProfileAuthenticator.java
index 195078f7ba0d801fba1a8bf29b07b0c5e85a6628..476002e2d28c079d354a35501e2412e43f78c098 100644
--- a/pki/base/common/src/com/netscape/certsrv/profile/IProfileAuthenticator.java
+++ b/pki/base/common/src/com/netscape/certsrv/profile/IProfileAuthenticator.java
@@ -89,7 +89,7 @@ public interface IProfileAuthenticator extends IAuthManager {
      *
      * @return a list of property names
      */
-    public Enumeration getValueNames();
+    public Enumeration<String> getValueNames();
 
     /**
      * Checks if the value of the given property should be
diff --git a/pki/base/common/src/com/netscape/certsrv/profile/IProfileInput.java b/pki/base/common/src/com/netscape/certsrv/profile/IProfileInput.java
index 6d861579c54e9330f033c7252645ebf80d009c9c..35453e7d5a298284c8c10ecbf266b7863d1ac115 100644
--- a/pki/base/common/src/com/netscape/certsrv/profile/IProfileInput.java
+++ b/pki/base/common/src/com/netscape/certsrv/profile/IProfileInput.java
@@ -83,7 +83,7 @@ public interface IProfileInput extends IConfigTemplate {
      *
      * @return a list of property names
      */
-    public Enumeration getValueNames();
+    public Enumeration<String> getValueNames();
 
     /**
      * Retrieves the descriptor of the given value 
diff --git a/pki/base/common/src/com/netscape/certsrv/profile/IProfileOutput.java b/pki/base/common/src/com/netscape/certsrv/profile/IProfileOutput.java
index b4654f408c7f6645fb0af213828978d0452b9cbd..6dbfea51cae62426b995535cc0ed5446a4f9ea07 100644
--- a/pki/base/common/src/com/netscape/certsrv/profile/IProfileOutput.java
+++ b/pki/base/common/src/com/netscape/certsrv/profile/IProfileOutput.java
@@ -83,7 +83,7 @@ public interface IProfileOutput extends IConfigTemplate {
      *
      * @return a list of property names
      */
-    public Enumeration getValueNames();
+    public Enumeration<String> getValueNames();
 
     /**
      * Retrieves the descriptor of the given value 
diff --git a/pki/base/common/src/com/netscape/certsrv/profile/IProfileSubsystem.java b/pki/base/common/src/com/netscape/certsrv/profile/IProfileSubsystem.java
index 795a19c0e7a44f903e319e4cd204ad55f788268a..6f2fef37831fa6cd13a96b8feb89f8ba00ca28a4 100644
--- a/pki/base/common/src/com/netscape/certsrv/profile/IProfileSubsystem.java
+++ b/pki/base/common/src/com/netscape/certsrv/profile/IProfileSubsystem.java
@@ -124,7 +124,7 @@ public interface IProfileSubsystem extends ISubsystem {
      *
      * @return a list of profile ids
      */
-    public Enumeration getProfileIds();
+    public Enumeration<String>  getProfileIds();
 
     /**
      * Checks if owner id should be enforced during profile approval.
diff --git a/pki/base/common/src/com/netscape/certsrv/property/IConfigTemplate.java b/pki/base/common/src/com/netscape/certsrv/property/IConfigTemplate.java
index f435db50c705f8608a5c78f85576b0daa176acce..e40c98fa9222afd9790f40861cb64a2956393787 100644
--- a/pki/base/common/src/com/netscape/certsrv/property/IConfigTemplate.java
+++ b/pki/base/common/src/com/netscape/certsrv/property/IConfigTemplate.java
@@ -41,7 +41,7 @@ public interface IConfigTemplate {
      * 
      * @return parameter names
      */
-    public Enumeration getConfigNames();
+    public Enumeration<String> getConfigNames();
 
     /**
      * Returns the descriptors of configuration parameter.
diff --git a/pki/base/common/src/com/netscape/certsrv/property/PropertySet.java b/pki/base/common/src/com/netscape/certsrv/property/PropertySet.java
index 360477fe914849c290a762d15ea9c70b49932ef8..f308a3e7e49f90b8763926ad08894536aa61505b 100644
--- a/pki/base/common/src/com/netscape/certsrv/property/PropertySet.java
+++ b/pki/base/common/src/com/netscape/certsrv/property/PropertySet.java
@@ -26,7 +26,7 @@ import java.util.Hashtable;
  */
 public class PropertySet {
 
-  private Hashtable mProperties = new Hashtable();
+  private Hashtable<String, IDescriptor> mProperties = new Hashtable<String, IDescriptor>();
 
   public PropertySet()
   {
@@ -37,7 +37,7 @@ public class PropertySet {
      mProperties.put(name, desc);
   }
 
-  public Enumeration getNames()
+  public Enumeration<String> getNames()
   {
     return mProperties.keys();
   }
diff --git a/pki/base/common/src/com/netscape/certsrv/ra/IRegistrationAuthority.java b/pki/base/common/src/com/netscape/certsrv/ra/IRegistrationAuthority.java
index 62fe529f021f379d98534fb7629d622a9bcc4319..3ab3a08480275c4f0dddc24ddc25f3d6db0cfdc3 100644
--- a/pki/base/common/src/com/netscape/certsrv/ra/IRegistrationAuthority.java
+++ b/pki/base/common/src/com/netscape/certsrv/ra/IRegistrationAuthority.java
@@ -168,5 +168,5 @@ public interface IRegistrationAuthority extends ISubsystem {
      *
      * @return name enumeration of all request listeners
      */
-    public Enumeration getRequestListenerNames();
+    public Enumeration<String> getRequestListenerNames();
 }
diff --git a/pki/base/common/src/com/netscape/certsrv/registry/IPluginRegistry.java b/pki/base/common/src/com/netscape/certsrv/registry/IPluginRegistry.java
index 0497562be45b780e3fc8df4601788fade26e8995..7631f3eaf353c778e3ec537a5c6c6dce8ba66622 100644
--- a/pki/base/common/src/com/netscape/certsrv/registry/IPluginRegistry.java
+++ b/pki/base/common/src/com/netscape/certsrv/registry/IPluginRegistry.java
@@ -49,7 +49,7 @@ public interface IPluginRegistry extends ISubsystem {
      *
      * @return a list of String-based names
      */
-    public Enumeration getTypeNames();
+    public Enumeration<String> getTypeNames();
 
     /**
      * Returns a list of plugin identifiers of the given type.
@@ -57,7 +57,7 @@ public interface IPluginRegistry extends ISubsystem {
      * @param type plugin type
      * @return a list of plugin IDs
      */
-    public Enumeration getIds(String type);
+    public Enumeration<String> getIds(String type);
 
     /**
      * Retrieves the plugin information.
diff --git a/pki/base/common/src/com/netscape/certsrv/request/IRequest.java b/pki/base/common/src/com/netscape/certsrv/request/IRequest.java
index c509e2966cd1dbcdf8e4e18289ae1a4041f7ce56..477a14c65bb5526db5b4f5ba2f48f2db2beacd19 100644
--- a/pki/base/common/src/com/netscape/certsrv/request/IRequest.java
+++ b/pki/base/common/src/com/netscape/certsrv/request/IRequest.java
@@ -643,7 +643,7 @@ public interface IRequest {
      * @param key  The extdata key
      * @return  A Vector of strings, or null on error.
      */
-    public Vector getExtDataInStringVector(String key);
+    public Vector<String> getExtDataInStringVector(String key);
 
     /**
      * Gets boolean value for given type or default value
diff --git a/pki/base/common/src/com/netscape/certsrv/usrgrp/IUGSubsystem.java b/pki/base/common/src/com/netscape/certsrv/usrgrp/IUGSubsystem.java
index e575c58bda1676bc01a0b9c94d33acd57b04b3d9..ff6f7be6f2aa5bca8b64a34b03f53cfa372e374b 100644
--- a/pki/base/common/src/com/netscape/certsrv/usrgrp/IUGSubsystem.java
+++ b/pki/base/common/src/com/netscape/certsrv/usrgrp/IUGSubsystem.java
@@ -58,7 +58,7 @@ public interface IUGSubsystem extends ISubsystem, IUsrGrp {
      * @return list of users
      * @exception EUsrGrpException thrown when any internal error occurs
      */
-    public Enumeration listUsers(String filter) throws EUsrGrpException;
+    public Enumeration<IUser> listUsers(String filter) throws EUsrGrpException;
 
     /**
      * Adds the given user to the internal database
@@ -107,7 +107,7 @@ public interface IUGSubsystem extends ISubsystem, IUsrGrp {
      * @param filter the search filter
      * @return a list of groups that match the given search filter
      */
-    public Enumeration findGroups(String filter);
+    public Enumeration<IGroup> findGroups(String filter);
 
     /**
      * Find a group for the given name
@@ -125,7 +125,7 @@ public interface IUGSubsystem extends ISubsystem, IUsrGrp {
      * its description.
      * @exception EUsrGrpException thrown when failed to list groups
      */
-    public Enumeration listGroups(String filter) throws EUsrGrpException;
+    public Enumeration<IGroup> listGroups(String filter) throws EUsrGrpException;
 
     /**
      * Retrieves a group from LDAP for the given group name
diff --git a/pki/base/common/src/com/netscape/cms/authentication/UidPwdPinDirAuthentication.java b/pki/base/common/src/com/netscape/cms/authentication/UidPwdPinDirAuthentication.java
index 116054181f9786806f04cd0a42d585d8b9db90cf..ce60bf8de976f15eb008eba17bfe6630aaa31eea 100644
--- a/pki/base/common/src/com/netscape/cms/authentication/UidPwdPinDirAuthentication.java
+++ b/pki/base/common/src/com/netscape/cms/authentication/UidPwdPinDirAuthentication.java
@@ -415,8 +415,8 @@ public class UidPwdPinDirAuthentication extends DirBasedAuthentication
     /**
      * Retrieves a list of names of the value parameter.
      */
-    public Enumeration getValueNames() {
-        Vector v = new Vector();
+    public Enumeration<String> getValueNames() {
+        Vector<String> v = new Vector<String>();
 
         v.addElement(CRED_UID);
         v.addElement(CRED_PWD);
diff --git a/pki/base/common/src/com/netscape/cms/notification/MailNotification.java b/pki/base/common/src/com/netscape/cms/notification/MailNotification.java
index 1e409af8769676af9bda5c53605627608c32abef..af6515843022d84201174a2f931fc28f435bc066 100644
--- a/pki/base/common/src/com/netscape/cms/notification/MailNotification.java
+++ b/pki/base/common/src/com/netscape/cms/notification/MailNotification.java
@@ -170,7 +170,7 @@ public class MailNotification implements IMailNotification {
      * sets the recipients' email addresses
      * @param addresses a list of email addresses of the recipients
      */
-    public void setTo(Vector addresses) {
+    public void setTo(Vector<String> addresses) {
         // concatenate addresses into comma separated mTo String
 
     }
diff --git a/pki/base/common/src/com/netscape/cms/profile/def/EnrollDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/EnrollDefault.java
index b5afc1c79e39049eaaad7e3cea22bd02a685255f..71cccdff5d25a65ef69eedc4092c6150ed2b87b7 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/EnrollDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/EnrollDefault.java
@@ -80,13 +80,13 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
     public static final String GN_OID_NAME = "OIDName";
 
     protected IConfigStore mConfig = null;
-    protected Vector mConfigNames = new Vector();
-    protected Vector mValueNames = new Vector();
+    protected Vector<String> mConfigNames = new Vector<String>();
+    protected Vector<String> mValueNames = new Vector<String>();
 
     public EnrollDefault() {
     }
 
-    public Enumeration getConfigNames() {
+    public Enumeration<String> getConfigNames() {
         return mConfigNames.elements();
     }
 
@@ -212,7 +212,7 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
         mValueNames.addElement(name);
     }
 
-    public Enumeration getValueNames() {
+    public Enumeration<String> getValueNames() {
         return mValueNames.elements();
     }
 
@@ -291,7 +291,7 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
                     info.get(X509CertInfo.EXTENSIONS);
             if (exts == null)
                 return;
-            Enumeration e = exts.getNames();
+            Enumeration<?> e = exts.getNames();
 
             while (e.hasMoreElements()) {
                 String n = (String) e.nextElement();
@@ -323,7 +323,7 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
     protected Extension getExtension(String name, CertificateExtensions exts) {
         if (exts == null)
             return null;
-        Enumeration e = exts.getElements();
+        Enumeration<?> e = exts.getElements();
 
         while (e.hasMoreElements()) {
             Extension ext = (Extension) e.nextElement();
@@ -515,7 +515,7 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
               String realm = nameValue.substring(pos0 + 1, pos1).trim();
               String name_type = nameValue.substring(pos1 + 1, pos2).trim();
               String name_strings = nameValue.substring(pos2 + 1).trim();
-              Vector strings = new Vector();
+              Vector<String> strings = new Vector<String>();
               StringTokenizer st = new StringTokenizer(name_strings, ",");
               while (st.hasMoreTokens()) {
                      strings.addElement(st.nextToken());
@@ -637,7 +637,7 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
         return true;
     }
 
-    protected String buildRecords(Vector recs) throws EPropertyException {
+    protected String buildRecords(Vector<?> recs) throws EPropertyException {
         StringBuffer sb = new StringBuffer();
 
         for (int i = 0; i < recs.size(); i++) {
@@ -646,7 +646,7 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
             sb.append("Record #");
             sb.append(i);
             sb.append("\r\n");
-            Enumeration e = pairs.getNames();
+            Enumeration<?> e = pairs.getNames();
 
             while (e.hasMoreElements()) {
                 String key = (String) e.nextElement();
@@ -663,10 +663,10 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
         return sb.toString();
     }
 
-    protected Vector parseRecords(String value) throws EPropertyException {
+    protected Vector<NameValuePairs> parseRecords(String value) throws EPropertyException {
         StringTokenizer st = new StringTokenizer(value, "\r\n");
         int num = 0;
-        Vector v = new Vector();
+        Vector<NameValuePairs> v = new Vector<NameValuePairs>();
         NameValuePairs nvps = null;
 
         while (st.hasMoreTokens()) {
diff --git a/pki/base/common/src/com/netscape/cms/profile/def/NameConstraintsExtDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/NameConstraintsExtDefault.java
index f6ddd91536a2f18dc5341c98dbad19e9ac97e390..065b30444676ade5f9c660148a1d2fbd825982b0 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/NameConstraintsExtDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/NameConstraintsExtDefault.java
@@ -163,7 +163,7 @@ public class NameConstraintsExtDefault extends EnrollExtDefault {
     }
 
 
-    public Enumeration getConfigNames() {
+    public Enumeration<String> getConfigNames() {
         refreshConfigAndValueNames();
         return super.getConfigNames();
     }
